 

/**
 * ein Skispringer hat einen Namen und verwaltet in zwei Durchgngen Punkte
 * <p>Qualitaets- und UnterstuetzungsAgentur  Landesinstitut fr Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 *
 * @version 2.1 28.04.2014
 */
public class Skispringer {

	public static final int DURCHGANG1 = 1;
	public static final int DURCHGANG2 = 2;
	public static final int GESAMT = 3;

	// Attribute
	private String name;
	private int punkte1, punkte2;

	/**
	 * Ein neuer Skispringer mit dem angegebenen Namen wird erzeugt. Er hat in
	 * beiden Durchgaengen noch 0 Punkte
	 * 
	 * @param name
	 */
	public Skispringer(String name) {
		this.name = name;
		this.punkte1 = 0;
		this.punkte2 = 0;
	}

	/**
	 * Der Name des Skispringers wird geliefert.
	 */
	public String gibName() {
		return name;
	}

	/**
	 * Die Punktzahl des Skispringers aus dem angegebenen Durchgang wird
	 * geliefert.
	 */
	public int gibPunkte(int pDurchgang) {
		if (pDurchgang == Skispringer.DURCHGANG1) {
			return punkte1;
		} else if (pDurchgang == Skispringer.DURCHGANG2) {
			return punkte2;
		} else if (pDurchgang == Skispringer.GESAMT) {
			return punkte1 + punkte2;
		} else {
			return -1;
		}
	}

	/**
	 * Die Punktzahl des Skispringers im angegebenen Durchgang wird gesetzt.
	 */
	public void setzePunkte(int pDurchgang, int pNeuePunkte) {
		if (pDurchgang == Skispringer.DURCHGANG1) {
			punkte1 = pNeuePunkte;
		} else if (pDurchgang == Skispringer.DURCHGANG2) {
			punkte2 = pNeuePunkte;
		}
	}
}
