 /**
 * <p>Qualitaets- und UnterstuetzungsAgentur - Landesinstitut fuer Schule, Materialien zum schulinternen Lehrplan Informatik SII</p>
 *
 * @version 1.1; April 2014
 */

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Random;

import javax.swing.*;
import javax.swing.border.*;

public class WettkampfFrame extends JFrame {

	private JPanel contentPane;
	private Wettkampfergebnis we;

	JButton btnNeuerSchler;
	JButton btnSave;
	JButton btnLoad;

	JLabel lblBundesjugendspiele;

	JSeparator separator;

	JTextArea anzeige;

	JRadioButton rdbtnLauf;
	JRadioButton rdbtnSprung;
	JRadioButton rdbtnWurf;
	JRadioButton rdbtnGesamt;

	private final ButtonGroup buttonGroup = new ButtonGroup();

	private JButton btnSortierenDurchAuswahl;
	private JButton btnSortierenDurchEinfuegen;
	private JButton btnSortierenDurchBubble;
	private JButton btnQuicksort;
	private JButton btnMergesort;

	private JPanel panel;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					WettkampfFrame frame = new WettkampfFrame();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	private void erzeugeBeispiele() {
		Random r = new Random();
		for (int i = 0; i < 100; i++) {
			String n = "Name" + i;
			String v = "Vorname" + i;
			String k = "Klasse_7";
			int ps = r.nextInt(100);
			int pl = r.nextInt(100);
			int pw = r.nextInt(100);
			Wettkampfkarte wk = new Wettkampfkarte(n, v, k);
			wk.setzePunkte(Wettkampfkarte.SPRUNG, ps);
			wk.setzePunkte(Wettkampfkarte.LAUF, pl);
			wk.setzePunkte(Wettkampfkarte.WURF, pw);
			we.ergaenzeKarte(wk);
		}
	}

	/**
	 * Create the frame.
	 */
	public WettkampfFrame() {
		this.we = new Wettkampfergebnis();
		//erzeugeBeispiele();
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 696, 522);
		contentPane = new JPanel();
		contentPane.setBackground(UIManager.getColor("Button.background"));
		setContentPane(contentPane);
		contentPane.setLayout(null);

		lblBundesjugendspiele = new JLabel("Bundesjugendspiele");
		lblBundesjugendspiele.setFont(new Font("Tahoma", Font.BOLD, 20));
		lblBundesjugendspiele.setHorizontalAlignment(SwingConstants.CENTER);
		lblBundesjugendspiele.setBounds(10, 11, 668, 32);
		contentPane.add(lblBundesjugendspiele);

		separator = new JSeparator();
		separator.setBounds(10, 54, 668, 2);
		contentPane.add(separator);

		btnNeuerSchler = new JButton("Neuen Schueler anf\u00FCgen");
		btnNeuerSchler.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				neuerSchueler_JOP();
			}
		});
		btnNeuerSchler.setBounds(10, 67, 210, 23);
		contentPane.add(btnNeuerSchler);

		btnSave = new JButton("Wettkampfkarten sichern");
		btnSave.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				writeData();
			}
		});
		btnSave.setBounds(10, 120, 210, 23);
		contentPane.add(btnSave);

		btnLoad = new JButton("Wettkampfkarten laden");
		btnLoad.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				readData();
				we.reset();
				showActual();
			}
		});
		btnLoad.setBounds(10, 154, 210, 23);
		contentPane.add(btnLoad);

		panel = new JPanel();
		panel.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED,
				null, null), "Sortieren", TitledBorder.LEADING,
				TitledBorder.BELOW_TOP, null, new Color(0, 0, 0)));
		panel.setBounds(395, 71, 283, 265);
		contentPane.add(panel);
		panel.setLayout(null);

		rdbtnLauf = new JRadioButton("nach den Punkten beim Laufen");
		rdbtnLauf.setBounds(38, 21, 226, 23);
		panel.add(rdbtnLauf);
		buttonGroup.add(rdbtnLauf);
		rdbtnLauf.setSelected(true);

		rdbtnSprung = new JRadioButton("nach den Punkten beim Springen");
		rdbtnSprung.setBounds(38, 41, 226, 23);
		panel.add(rdbtnSprung);
		buttonGroup.add(rdbtnSprung);

		rdbtnWurf = new JRadioButton("nach den Punkten beim Werfen");
		rdbtnWurf.setBounds(38, 61, 226, 23);
		panel.add(rdbtnWurf);
		buttonGroup.add(rdbtnWurf);

		rdbtnGesamt = new JRadioButton("nach der Punktesumme");
		rdbtnGesamt.setBounds(38, 81, 226, 23);
		panel.add(rdbtnGesamt);
		buttonGroup.add(rdbtnGesamt);

		btnSortierenDurchAuswahl = new JButton("durch Auswahl");
		btnSortierenDurchAuswahl.setBounds(38, 111, 132, 23);
		panel.add(btnSortierenDurchAuswahl);

		btnSortierenDurchEinfuegen = new JButton("durch Einfuegen");
		btnSortierenDurchEinfuegen.setBounds(38, 141, 132, 23);
		panel.add(btnSortierenDurchEinfuegen);

		btnSortierenDurchBubble = new JButton("BubbleSort");
		btnSortierenDurchBubble.setBounds(38, 171, 132, 23);
		panel.add(btnSortierenDurchBubble);
		
		btnQuicksort = new JButton("Quicksort");
		btnQuicksort.setBounds(38, 201, 132, 23);
		panel.add(btnQuicksort);
		
		btnMergesort = new JButton("Mergesort");
		btnMergesort.setBounds(38, 231, 132, 23);
		panel.add(btnMergesort);
		
		

		anzeige = new JTextArea();
		anzeige.setBackground(UIManager.getColor("Button.background"));
		anzeige.setBorder(new LineBorder(new Color(0, 0, 0)));

		JScrollPane sp = new JScrollPane(anzeige);
		sp.setBounds(10, 188, 375, 285);
		contentPane.add(sp);

		btnSortierenDurchBubble.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				bubbleSortAction();
			}
		});
		btnSortierenDurchEinfuegen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				einfuegSortAction();
			}
		});
		btnSortierenDurchAuswahl.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				auswahlSortAction();
			}
		});
		btnQuicksort.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				quickSortAction();
			}
		});
		btnMergesort.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				mergeSortAction();
			}
		});
		
		showActual();
	}

	private void showActual() {
		we.reset();
		String inhalt = "";
		while (we.hasAccess()) {
			Wettkampfkarte wk = we.aktuelleWettkampfkarte();
			inhalt += wk.toString() + "\n";
			we.next();
		}
		this.anzeige.setText(inhalt);
	}

	private void sortAction(int pVerfahren) {
		if (this.rdbtnLauf.isSelected()) {
			sortAction(Wettkampfkarte.LAUF, pVerfahren);
		} else if (this.rdbtnSprung.isSelected()) {
			sortAction(Wettkampfkarte.SPRUNG, pVerfahren);
		} else if (this.rdbtnWurf.isSelected()) {
			sortAction(Wettkampfkarte.WURF, pVerfahren);
		} else if (this.rdbtnGesamt.isSelected()) {
			sortAction(Wettkampfkarte.GESAMT, pVerfahren);
		}

		this.we.reset();
		showActual();
	}

	private void sortAction(int pDisziplin, int pVerfahren) {
      	this.we.sortiereNach(pDisziplin, pVerfahren);
	}

	private void auswahlSortAction() {
		sortAction(Wettkampfergebnis.AUSWAHL);
	}

	private void einfuegSortAction() {
		sortAction(Wettkampfergebnis.EINFUEGEN);
	}

	private void bubbleSortAction() {
		sortAction(Wettkampfergebnis.BUBBLESORT);
	}
	
	private void quickSortAction() {
		sortAction(Wettkampfergebnis.QUICKSORT);
	}
	
	private void mergeSortAction() {
		sortAction(Wettkampfergebnis.MERGESORT);
	}

	private void neuerSchueler_JOP() {
		JTextField name = new JTextField();
		JTextField vorname = new JTextField();
		JTextField klasse = new JTextField();
		JTextField punkteLauf = new JTextField();
		JTextField punkteSprung = new JTextField();
		JTextField punkteWurf = new JTextField();

		Object[] message = { "Name", name, "Vorname", vorname, "Klasse",
				klasse, "Punkte beim Laufen", punkteLauf,
				"Punkte beim Springen", punkteSprung, "Punkte beim Werfen",
				punkteWurf };

		JOptionPane pane = new JOptionPane(message, JOptionPane.PLAIN_MESSAGE,
				JOptionPane.OK_CANCEL_OPTION);
		pane.createDialog(this, "Neuer Schueler").setVisible(true);
		if (pane.getValue() != null
				&& (int) pane.getValue() == JOptionPane.OK_OPTION) {
			String inhalt = name.getText() + "," + vorname.getText() + ","
					+ klasse.getText() + "," + punkteLauf.getText() + ","
					+ punkteSprung.getText() + "," + punkteWurf.getText();

			Wettkampfkarte wk = new Wettkampfkarte(inhalt);
			we.ergaenzeKarte(wk);
			we.reset();
			showActual();
		} else {
			// System.out.println("Abgebrochen!");
		}
	}

	/**
	 * Die Wettkampfkarten wurden im Projektordner gespeichert.
	 */
	private void writeData() {
		PrintWriter pWriter = null;
		try {
			pWriter = new PrintWriter(new BufferedWriter(new FileWriter(
					"Wettkampfergebnis.txt")));
			we.reset();
			while (we.hasAccess()) {
				Wettkampfkarte wk = we.aktuelleWettkampfkarte();
				pWriter.println(wk.toString());
				we.next();
			}
		} catch (IOException ioe) {
			ioe.printStackTrace();
		} finally {
			if (pWriter != null) {
				pWriter.flush();
				pWriter.close();
			}
		}
	}

	/**
	 * Wenn vorhanden, wurden die Wettkampfkarten aus der Sicherungsdatei im
	 * Projektordner geladen.
	 */
	private void readData() {
		{
			try {
				FileReader fr = new FileReader("Wettkampfergebnis.txt");
				BufferedReader br = new BufferedReader(fr);

				String zeile = "";
				we = new Wettkampfergebnis();

				while ((zeile = br.readLine()) != null) {
					Wettkampfkarte wk = new Wettkampfkarte(zeile);
					we.ergaenzeKarte(wk);
				}

				br.close();
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
}
